#ifndef _PCPLIB_H_
#define _PCPLIB_H_

#ifdef __GNUG__
#   define CDECL "C"
#else
#   define CDECL
#endif

extern CDECL int pcplib_init(void);
extern CDECL int query_projector_power(void);
extern CDECL void query_projector_status(void);
extern CDECL int pcp_set_serialDevice(const char *, char *);
extern CDECL int pcp_set_serialSpeed(int, char *);
extern CDECL void pcp_set_timeoutDefault(int);
extern CDECL int query_power(void);

#define _Fno(A) extern CDECL int pcp_##A##_command(void);
#define _Fint(A) extern CDECL int pcp_##A##_command(int);

_Fno(powerOn)
_Fno(powerOff)
_Fno(shutter)
_Fint(freeze)
_Fint(lampPower)
_Fint(contrast)
_Fint(brightness)
_Fint(color)
_Fint(sharpness)
_Fint(tint)
_Fint(backgroundColor)
_Fint(pictureMode)

#undef _Fint
#undef _Fno

#define PCP_OK       0
#define PCP_TIMEOUT -1
#define PCP_ERESP   -2
#define PCP_ER401   -3
#define PCP_ER402   -4
#define PCP_NOIMPL  -5
#define PCP_NOPORT  -6

#define PCP_ERR_TIMEOUT	"timeout"
#define PCP_ERR_ERESP	"invalid response"

#define PCP_STR_ERR(A) \
    ((A)==PCP_TIMEOUT ? PCP_ERR_TIMEOUT : (A)==PCP_ERESP ? PCP_ERR_ERESP : "")

#define _F(A) \
    extern CDECL int pcp_get_ ##A (void);

_F(power)
_F(freeze)
_F(shutter)
_F(lampPower)
_F(autoKeystone)
_F(autoRGB)
_F(autoYPbPr)
_F(autoSetup)
_F(volume)
_F(brightness)
_F(color)
_F(contrast)
_F(sharpness)
_F(tint)
_F(backgroundColor)
_F(pictureMode)
_F(lampOnTime)
_F(lampOnCondition)

#undef _F

#define COMBO_SERIAL_DEVICE_0 "/dev/ttyS0 (COM1)"
#define COMBO_SERIAL_DEVICE_1 "/dev/ttyS1 (COM2)"

const int serialSpeedDefault = 1;

extern const char * serialSpeedVect[];

#endif
